package de.ozgcloud.eingang.enterprise.entry;

import java.util.List;

import com.fasterxml.jackson.annotation.JsonProperty;

import lombok.Builder;
import lombok.Getter;
import lombok.extern.jackson.Jacksonized;

@Builder
@Getter
@Jacksonized
public class EntryData {

	private ControlData control;
	private List<EntryFormDataItem> formData;

	@Builder
	@Getter
	@Jacksonized
	public static class ControlData {
		private String transactionId;
		private String zustaendigeStelle;
		private String[] leikaIds;
		private ResultEndpoint resultEndpoint;
		private String formId;
		@JsonProperty("name")
		private String formName;
		private Servicekonto serviceKonto;

		private Representations representations;

		@Builder
		@Getter
		@Jacksonized
		public static class ResultEndpoint {
			private String address;
		}

		@Builder
		@Getter
		@Jacksonized
		public static class Representations {
			private String formData;
			private String formDataModell;
		}
	}

	@Builder
	@Getter
	@Jacksonized
	public static class Servicekonto {
		private String type;
		private PostfachAddress postfachAddress;
	}

	@Builder
	@Getter
	@Jacksonized
	public static class PostfachAddress {
		private String identifier;
		private String type;
	}
}
